package org.mathcs.ibookmark;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.Preference;
import android.preference.PreferenceManager;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.PreferenceFragment;

public class SettingsFragment extends PreferenceFragment
{
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

		// Load the preferences from an XML resource
		addPreferencesFromResource(R.xml.preferences);

		Preference resetButton = (Preference)findPreference("resetPreferencesKey");
		resetButton.setOnPreferenceClickListener(new OnPreferenceClickListener()
				{
	        		public boolean onPreferenceClick(Preference preference)
	        		{
	        			resetPreferencesConfirm();
				    	return true;
	        		}
				});

	}
	
	private void resetPreferencesConfirm()
	{
		AlertDialog.Builder alert = new AlertDialog.Builder(getActivity());
		alert.setTitle("Are you sure?");
		alert.setMessage("Do you really want to reset all settings to their default values?");
		alert.setPositiveButton("Okay", new DialogInterface.OnClickListener()
				{
					public void onClick(DialogInterface dialog, int button)
					{
						resetPreferences();
						getActivity().finish();
					}
				});
		alert.setNegativeButton("Cancel", null);
		alert.show();
	}

	public void resetPreferences()
	{
		// I've added this other code to clear all settings first, then reset them to their
		// default value. The 'setDefaultValues' method with 'true' as last input should
		// actually do the trick already, but it seems to not work for me. Hence, added the
		// preferences.clear().committ() code.
		SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(getActivity());
		preferences.edit().clear().commit();
		PreferenceManager.setDefaultValues(getActivity(), R.xml.preferences, true);
	}
}